diff --git a/debmirror b/debmirror
index 0c50a2f..83c1417 100755
--- a/debmirror
+++ b/debmirror
@@ -2391,7 +2391,7 @@ sub cleanup_unknown_files {
   if ($use_cache) {
     say(": using cache.");
     foreach my $file (sort keys %files) {
-      next if (@di_dists && $file =~ m:installer-\w+/current/images/:);
+      next if (@di_dists && $file =~ m:installer-\w(-|\w)*/current/images/:);
       if ($files{$file} == 2 && -f $file) {
 	say("deleting $file") if ($verbose);
 	if (! $do_dry_run) {
@@ -2408,7 +2408,7 @@ sub cleanup_unknown_files {
     foreach my $file (`find . -type f`) {
       chomp $file;
       $file=~s:^\./::;
-      next if (@di_dists && $file =~ m:installer-\w+/current/images/:);
+      next if (@di_dists && $file =~ m:installer-\w(-|\w)*/current/images/:);
       unless ((exists $files{$file} && $files{$file} != 2) or
 	      (defined($ignore) && $file=~/$ignore/o)) {
 	say("deleting $file") if ($verbose);
@@ -2466,7 +2466,7 @@ sub di_add_files {
   foreach my $dist (keys %distset) {
     next unless exists $distset{$dist}{"d-i"};
     foreach my $arch (@di_arches) {
-      next if $arch =~ /kfreebsd-/;
+      next if $arch eq "all";
 
       my $image_dir = "dists/$dist/main/installer-$arch/current/images";
       make_dir ("$tdir/$image_dir");
@@ -2547,7 +2547,7 @@ sub di_get_files {
 sub di_cleanup {
   # Clean up obsolete files
   foreach my $image_dir (`find dists/ -type d -name images`) {
-    next unless $image_dir =~ m:/installer-\w+/current/images$:;
+    next unless $image_dir =~ m:/installer-\w(-|\w)*/current/images$:;
     chomp $image_dir;
     chdir("$image_dir") or die "unable to chdir($image_dir): $!\n";
     foreach my $file (`find . -type f`) {
